• 技术文章 >后端开发 >Golang

    Go语言error类型是什么

    青灯夜游青灯夜游2023-01-12 11:09:52原创58

    在Go语言,error是一个接口类型。error接口类型是作为错误处理的标准模式,如果函数要返回错误,则返回值类型列表中肯定包含error;error处理过程类似于C语言中的错误码,可逐层返回,直到被处理。error接口类型定义为仅包含一个方法的 Error() string;所有实现该接口的类型都可以当作一个错误类型。

    本教程操作环境:windows7系统、GO 1.18版本、Dell G3电脑。

    Go 错误是指程序执行过程中遇到与设计流程不相符的情况,引发的人为的或自动的反馈机制。有些错误有有意设计的,并增加了错误处理,或者反馈给用户等待处理,例如检查到除数为 0,会报错误,使得用户可以认识到自己的输入的问题,再如爬取指定页面信息的代码遇到了网络断开的情况;而另外错误则是程序设计考虑不周导致的BUG,比如数组访问下标越界,空指针操作导致崩溃等等。针对各种情况设计良好的错误处理是代码成熟的标志之一,也是必须积累的经验或者说需要周密的设计。

    Go语言的error类型

    Go 错误使用 error 表示,是一个接口类型,通常都是跟返回值一起声明的。

    错误处理在每个编程语言中都是一项重要内容,通常开发中遇到的分为异常与错误两种,Go语言中也不例外。

    在C语言中通过返回 -1 或者 NULL 之类的信息来表示错误,但是对于使用者来说,如果不查看相应的 API 说明文档,根本搞不清楚这个返回值究竟代表什么意思,比如返回 0 是成功还是失败?

    针对这样的情况,Go语言中引入 error 接口类型作为错误处理的标准模式,如果函数要返回错误,则返回值类型列表中肯定包含 error。error 处理过程类似于C语言中的错误码,可逐层返回,直到被处理。

    error 接口类型定义为仅包含一个方法的 Error() string。所有实现该接口的类型都可以当作一个错误类型。Error() 方法给出了错误的描述。这意味着可以给所有数据类型都配备错误类型。

    //The error built-in interface type is the conventional interface for representing an error condition, with the nil value representing no error. 
    type error interface {
        Error() string
    }
    //DNSError represents a DNS lookup error. 
    type DNSError struct {
        Err         string // description of the error
        Name        string // name looked for
        Server      string // server used
        IsTimeout   bool   // if true, timed out; not all timeouts set this
        IsTemporary bool   // if true, error is temporary; not all errors set this; added in Go 1.6
    }
    
    func (e *DNSError) Error() string
    
    func (e *DNSError) Temporary() bool
    //Temporary reports whether the DNS error is known to be temporary. This is not always known; a DNS lookup may fail due to a temporary error and return a DNSError for which Temporary returns false. 
    
    func (e *DNSError) Timeout() bool
    //Timeout reports whether the DNS lookup is known to have timed out. This is not always known; a DNS lookup may fail due to a timeout and return a DNSError for which Timeout returns false.

    具体看 *DNSError 就可以体会一个错误类型的定义。 *DNSError 包含5个字段结构体。Err 描述错误文字,Name 为查询的域名,Server 服务器用,IsTimeout 和 IsTemporary 为指示错误原因的两个布尔量。用下面的例子具体体会。

    func main() {
        name := "www.ilydsssss.com"
        addr, err := net.LookupHost(name)
        if errS, ok := err.(*net.DNSError); ok {
            fmt.Printf("%+v\n", *errS)
            fmt.Println(err)
        } else {
            fmt.Println(name, addr)
        }  
    }
    /* result for
    ------www.ilydsssss.com------------
    {Err:no such host Name:www.ilydsssss.com Server: IsTimeout:false IsTemporary:false}
    lookup www.ilydsssss.com: no such host
    
    ------------ www.iloveyou.com------------
    {Err:getaddrinfow: This is usually a temporary error during hostname resolution and means that the local server did not receive a response from an authoritative server. Name:www.iloveyou.com Server: IsTimeout:false IsTemporary:false}
    lookup www.iloveyou.com: getaddrinfow: This is usually a temporary error during hostname resolution and means that the local server did not receive a response from an authoritative server.
    传说中的发送DNS,没有返回的结果,原因你懂的, 这个是什么站点,noidea
    
    ----------- www.baidu.com ------------
    www.baidu.com [180.97.33.108 180.97.33.107]

    上述用例中,如果查询失败(就是指针不为nil),则进行了类型断言,如果是 *net.DNSError 指针,则打印结构体字段,并输出错误;否则打印域名和地址。可以看到定义两类错误中,上述查询并没有返回任何一种,但确实错误了。

    同时,也可猜测,func (e *DNSError) Error() string 的定义就是 return "look " + e.Name + e.Err。

    error 的创建

    Go 内部的错误反馈就是这样定义,如何定义新的错误类型呢。

    新建一个结构体,仿照上述 DNSError 建立一个需要保存错误的结构,同时实现 error 接口,就可以实现。

    package errors
    // New returns an error that formats as the given text.
    func New(text string) error {
        return &errorString{text}
    }
    // errorString is a trivial implementation of error.
    type errorString struct {
        s string
    }
    func (e *errorString) Error() string {
        return e.s
    }

    errorString 是一个仅包含了一个字符串的结构体类型,同时实现了error接口,New() 函数只是利用一个错误描述的字符串初始化errorString并返回该结构体地址,这就使得一个简单的错误类型,可以随时被直接调用,而不用创建一个结构体并实现接口,如果需要,那就用方法1。

    fmt.Errorf() 函数签名:func Errorf(format string, a ...interface{}) error,它利用一个格式化的字符串,利用上述方法,返回一个签名。是否还记得 func Sprintf(format string, a ...interface{}) string, fmt.Errorf()实现也仅仅 return error.New(fmt.Sprintf(format string, a ...interface{}))

    错误处理

    当写一个库时,如果发生一个错误,一种方式就是按照上述所说,抛出一个错误,由上层或用户去决断如何处理,是退出还是提示修改;另一种方式就是抛出 panic 来终止程序,除非遇到特别严重的错误,什么叫严重呢?就是程序已经没有执行的必要了,莫不如抛出错误,直接退出。有两种情况可以考虑使用 panic: 1. 发生了一个不能恢复的错误,此时程序不能继续运行。2. 存在一个编程上的错误。

    当程序由 panic 引发终止时,可以使用 recover 重新获取该程序控制权。panic 和 recover 与其他语言中的 try-catch-finally 语句类似,只不过一般我们很少使用 panic 和 recover。

    内建函数 panic 的签名为:func panic(interface{}),此处接口为空接口,也可以理解为任意数据类型都可以输入,输入什么,则提示什么。

    func div(x, y int) float64 {
        defer fmt.Println("DIV ......")
        if y == 0 {
            panic(fmt.Sprintf("%d / %d, 除数为零, 无法计算", x, y))
        }
        return float64(x) / float64(y)
    }
    fmt.Println(div(3, 0))
    /* result
    panic: 3 / 0, 除数为零
    
    goroutine 1 [running]:
    main.div(0x3, 0x0, 0x2)
            error.go:10 +0x148
    main.main()
            error.go:25 +0x15a
    exit status 2
    */

    从上述例子可以看到,当函数发生 panic 时,它会终止运行,在执行完所有的延迟函数后,程序控制返回到该函数的调用方。这样的过程会一直持续下去,直到当前协程的所有函数都返回退出,然后程序会打印出 panic 信息,接着打印出堆栈跟踪,最后程序终止。

    recover 是一个内建函数,用于重新获得 panic 协程的控制。recover 函数的标签如下所示:func recover() interface{}。需要注意的是:只有在延迟函数的内部,调用 recover 才有用。在延迟函数内调用 recover,可以取到 panic 的错误信息,并且停止 panic 续发事件,程序运行恢复正常。如果在延迟函数的外部调用 recover,就不能停止 panic 续发事件。

    例如:

    import (
        "runtime/debug"
    )
    func recoverFdiv() {
        if r := recover(); r != nil {
            fmt.Println("来自 DIV 的恢复, 除数为零,下面是出错log记录")
            debug.PrintStack()
        }
    }
    
    func div(x, y int) float64 {
        defer recoverFdiv()
        if y == 0 {
            panic(fmt.Sprintf("%d / %d, 除数为零, 无法计算", x, y))
        }
        return float64(x) / float64(y)
    }
    fmt.Println(div(3, 0))
    
    /* result
    来自 DIV 的恢复, 除数为零,下面是出错log记录
    goroutine 1 [running]:
    runtime/debug.Stack(0xc000072008, 0xc00006fd68, 0x1)
            runtime/debug/stack.go:24 +0xae
    runtime/debug.PrintStack()
            runtime/debug/stack.go:16 +0x29
    main.recoverFdiv()
            D:/ZHY-L/OneDrive/文档/开发/goblog/myerror.go:12 +0x89
    panic(0x4b9620, 0xc000030040)
            runtime/panic.go:513 +0x1c7
    main.div(0x3, 0x0, 0x0)
            error.go:19 +0x186
    main.main()
            error.go:34 +0x15a
    0
    */

    如上所示,调用延迟函数 recoverFdiv(),它使用了 recover() 来停止 panic 续发事件,主函数还是继续执行了。同时,利用debug.PrintStack() 打印了 panic 记录,这样在保证程序继续执行的同时,也留下了调试宝贵的记录。

    同理,Go 内置的运行时错误(如数组越界)也会导致 panic。这等价于调用了内置函数 panic,其参数由接口类型 runtime.Error 给出。runtime.Error 接口的定义如下:

    type Error interface {  
        error
        // RuntimeError is a no-op function but
        // serves to distinguish types that are run time
        // errors from ordinary errors: a type is a
        // run time error if it has a RuntimeError method.
        RuntimeError()
    }

    【相关推荐:Go视频教程编程教学

    以上就是Go语言error类型是什么的详细内容,更多请关注php中文网其它相关文章!

    声明:本文内容由网友自发贡献,版权归原作者所有,本站不承担相应法律责任。如您发现有涉嫌抄袭侵权的内容,请联系admin@php.cn核实处理。
    专题推荐:go语言 Golang
    上一篇:go语言类型断言是啥 下一篇:自己动手写 PHP MVC 框架(40节精讲/巨细/新人进阶必看)

    相关文章推荐

    • Go语言中什么是包• golang怎么将通道关闭• go语言接口类型怎么转换• Go语言中goroutine是啥• Go语言GOPATH是什么• go语言中for range是什么结构
    1/1

    PHP中文网